#include "Compiler.h"
#include <filesystem>

Compiler::Compiler(std::string f)
: TypeCheck(), file(f), buf()
{
};

extern std::filesystem::path binaryPath;
const std::string Compiler::extension = "s";
void Compiler::externalCommand(std::filesystem::path lat) {
	auto obj = lat;
	obj.replace_extension("o");
	auto cmd = std::string("as --32 '") + lat.string() + "' -o '" + obj.string() + "'";
	cerr << cmd << endl;
	system(cmd.data());
	auto lib = binaryPath.parent_path() / "lib";
	auto runtime = lib / "runtime.o";
	auto result = obj;
	result.replace_extension("");
	cmd = std::string("ld -m elf_i386 -L'") + lib.string() + "' '" + runtime.string() + "' '" + obj.string() + "' -o '" + result.string() + "'";
	cerr << cmd << endl;
	system(cmd.data());
}

std::string Compiler::compile(Visitable *v) {
	check(v);
	for (auto i : {"printStr", "printInt", "readInt", "readStr", "error", "exit", "_start"}) {
		buf << ".globl " << i << "\n";
	}
	buf << "_start:\n"
		"pushl %%ebp\n"
		"movl %%esp, %%ebp\n"
		"call main\n"
		"pushl %%eax\n"
		"call exit\n";
	return buf.str();
}